
CraftGlobalNode = class( Turbine.UI.TreeNode );

function CraftGlobalNode:Constructor(players)
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
	self.classLabel:SetPosition( 6, 5 );
	self.classLabel:SetSize( 26, 24 );
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	local iconeTop = 5;
	local cookLabel = Turbine.UI.Control();
	cookLabel:SetParent( self );
	cookLabel:SetSize( 26, 24 );
	cookLabel:SetPosition( 43, iconeTop );
	cookLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	cookLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_cook.tga");
	self:CreateBestPlayerTooptipByCraft(players, cookLabel, "Cuisinier");
	
	local farmerLabel = Turbine.UI.Control();
	farmerLabel:SetParent( self );
	farmerLabel:SetSize( 26, 24 );
	farmerLabel:SetPosition( 69, iconeTop );
	farmerLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	farmerLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_farmer.tga");
	self:CreateBestPlayerTooptipByCraft(players, farmerLabel, "Fermier");
	
	local foresterLabel = Turbine.UI.Control();
	foresterLabel:SetParent( self );
	foresterLabel:SetSize( 26, 24 );
	foresterLabel:SetPosition( 95, iconeTop );
	foresterLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	foresterLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_forester.tga");
	self:CreateBestPlayerTooptipByCraft(players, foresterLabel, "Forestier");
	
	local jewellerLabel = Turbine.UI.Control();
	jewellerLabel:SetParent( self );
	jewellerLabel:SetSize( 26, 24 );
	jewellerLabel:SetPosition( 121, iconeTop );
	jewellerLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	jewellerLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_jeweller.tga");
	self:CreateBestPlayerTooptipByCraft(players, jewellerLabel, "Bijoutier");
	
	local metalsmithLabel = Turbine.UI.Control();
	metalsmithLabel:SetParent( self );
	metalsmithLabel:SetSize( 26, 24 );
	metalsmithLabel:SetPosition( 147, iconeTop );
	metalsmithLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	metalsmithLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_metalsmith.tga");
	self:CreateBestPlayerTooptipByCraft(players, metalsmithLabel, "Ferronnier");
	
	local prospectorLabel = Turbine.UI.Control();
	prospectorLabel:SetParent( self );
	prospectorLabel:SetSize( 26, 24 );
	prospectorLabel:SetPosition( 173, iconeTop );
	prospectorLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	prospectorLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_prospector.tga");
	self:CreateBestPlayerTooptipByCraft(players, prospectorLabel, "Prospecteur");
	
	local scholarLabel = Turbine.UI.Control();
	scholarLabel:SetParent( self );
	scholarLabel:SetSize( 26, 24 );
	scholarLabel:SetPosition( 199, iconeTop );
	scholarLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	scholarLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_scholar.tga");
	self:CreateBestPlayerTooptipByCraft(players, scholarLabel, "Erudit");
	
	local tailorLabel = Turbine.UI.Control();
	tailorLabel:SetParent( self );
	tailorLabel:SetSize( 26, 24 );
	tailorLabel:SetPosition( 225, iconeTop );
	tailorLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	tailorLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_tailor.tga");
	self:CreateBestPlayerTooptipByCraft(players, tailorLabel, "Tailleur");
	
	local weaponsmithLabel = Turbine.UI.Control();
	weaponsmithLabel:SetParent( self );
	weaponsmithLabel:SetSize( 26, 24 );
	weaponsmithLabel:SetPosition( 251, iconeTop );
	weaponsmithLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	weaponsmithLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_weaponsmith.tga");
	self:CreateBestPlayerTooptipByCraft(players, weaponsmithLabel, "Fabricant d'armes");
	
	local woodworkerLabel = Turbine.UI.Control();
	woodworkerLabel:SetParent( self );
	woodworkerLabel:SetSize( 26, 24 );
	woodworkerLabel:SetPosition( 277, iconeTop );
	woodworkerLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	woodworkerLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_woodworker.tga");
	self:CreateBestPlayerTooptipByCraft(players, woodworkerLabel, "Menuisier");

	self:UpdateNodeData();		
end

function CraftGlobalNode:CreateBestPlayerTooptipByCraft(players, component, craft)
	local topLevel = 0;
	local topPlayer = nil;
	local profId = 0;
	for i=1 , table.getn(players) , 1 do
		local playerData = players[i];
		if(table.getn(playerData.data.profession)==3) then
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Test craft de "..playerData.name.." [1]");
			if ((playerData.data.profession[1].name==craft) and (playerData.data.profession[1].level > topLevel)) then
				topLevel = playerData.data.profession[1].level;
				topPlayer = playerData;
				profId = 1;
			end

			if(playerData.data.profession[2].name==craft and playerData.data.profession[2].level > topLevel) then
				topLevel = playerData.data.profession[2].level;
				topPlayer = playerData;
				profId = 2;
			end
			if(playerData.data.profession[3].name==craft and playerData.data.profession[3].level > topLevel) then
				topLevel = playerData.data.profession[3].level;
				topPlayer = playerData;
				profId = 3;
			end
		else
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Pas de craft chez "..playerData.name);
		end
	end
	if(topLevel ~=0) then
		local prof1labelTooltip = "Niveau d'aptitude : "..self:GetCraftLevelById(topPlayer.data.profession[profId].level).."\n";
		if(topPlayer.data.profession[profId].levelXP ~= "0/0") then prof1labelTooltip = prof1labelTooltip.."Expérience restante : "..topPlayer.data.profession[profId].levelXP; end
		prof1labelTooltip = prof1labelTooltip.."\n\nNiveau de Maitrise : "..self:GetCraftLevelById(topPlayer.data.profession[profId].mastery).."\n";
		if(topPlayer.data.profession[profId].masteryXP ~= "0/0") then prof1labelTooltip = prof1labelTooltip.."Expérience restante : "..topPlayer.data.profession[profId].masteryXP; end
		--self.prof1Label.tooltip = ToolTip(self.prof1Label, topPlayer.data.profession[profId].name, prof1labelTooltip, ToolTipLayout.MEDIUM);	
		component.tooltip = ToolTip(component, "Meilleur "..craft.." : "..topPlayer.name, prof1labelTooltip , ToolTipLayout.MEDIUM);
		if(topPlayer.data.profession[profId].mastery > 12 ) then
			component:SetBackground("WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(craft, true));
		end
	else
		component.tooltip = ToolTip(component, craft, "Ce métier n'a été choisi par aucun joueur." , ToolTipLayout.SMALL);
	end
end

function CraftGlobalNode:GetPlayer()
	return self.player;
end

function CraftGlobalNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		self.player = p;
		-- TODO
	end
end

function CraftGlobalNode:GetCraftLevelById(level)
	if(level==1) then	return "Apprenti";
	elseif (level==2) then return "Compagnon";
	elseif (level==3) then return "Expert";
	elseif (level==4) then return "Artisan";
	elseif (level==5) then return "Maitre";
	elseif (level==6) then return "Supreme";
	elseif (level==7) then return "Ouestfolde";
	elseif (level==8) then return "Estemnet";
	elseif (level==9) then return "Ouestemnet";
	elseif (level==10) then return "Anorien";
	elseif (level==11) then return "Folde du Destin";
	elseif (level==12) then return "Crevasse de Fer";
	elseif (level==13) then return "Minas Ithil";
	elseif (level==0) then return "Débutant";
	else return "Niveau inconnu";
	end
end

function CraftGlobalNode:GetIconeByCraftName(craft, gold)
	if(craft == "Tailleur") then
		if(gold==true) then return "actionPicker_icon_craft_tailor_gold.tga"; end
		return "actionPicker_icon_craft_tailor.tga";
	elseif(craft=="Cuisinier") then
		if(gold==true) then return "actionPicker_icon_cook_gold.tga"; end
		return "actionPicker_icon_cook.tga";
	elseif(craft=="Fermier") then
		if(gold==true) then return "actionPicker_icon_craft_farmer_gold.tga"; end
		return "actionPicker_icon_craft_farmer.tga";
	elseif(craft=="Forestier") then
		if(gold==true) then return "actionPicker_icon_craft_forester_gold.tga"; end
		return "actionPicker_icon_craft_forester.tga";
	elseif(craft=="Prospecteur") then
		if(gold==true) then return "actionPicker_icon_craft_prospector_gold.tga"; end
		return "actionPicker_icon_craft_prospector.tga";
	elseif(craft=="Ferronnier") then
		if(gold==true) then return "actionPicker_icon_craft_metalsmith_gold.tga"; end
		return "actionPicker_icon_craft_metalsmith.tga";
	elseif(craft=="Erudit") then
		if(gold==true) then return "actionPicker_icon_craft_scholar_gold.tga"; end
		return "actionPicker_icon_craft_scholar.tga";
	elseif(craft=="Fabricant d'armes") then
		if(gold==true) then return "actionPicker_icon_craft_weaponsmith_gold.tga"; end
		return "actionPicker_icon_craft_weaponsmith.tga";
	elseif(craft=="Menuisier") then
		if(gold==true) then return "actionPicker_icon_craft_woodworker_gold.tga"; end
		return "actionPicker_icon_craft_woodworker.tga";
	else
		if(gold==true) then return "actionPicker_icon_craft_jeweller_gold.tga"; end
		return "actionPicker_icon_craft_jeweller.tga";
	end
end