import "WalmPlugins.BandOfFarmers.Tooltip";

CraftNode = class( Turbine.UI.TreeNode );

function CraftNode:Constructor(p, hightlight)
	self.player = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 140, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	-- if(self.player.data.level == nil) then
		-- self.playerNameLabel:SetText(self.player.name);
		-- self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	-- else
	self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	-- end
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(self.player.data.playerClass == 172) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga");
	elseif(self.player.data.playerClass == 214) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga");
	elseif(self.player.data.playerClass == 40) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga");
	elseif(self.player.data.playerClass == 23) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga");
	elseif(self.player.data.playerClass == 194) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga");
	elseif(self.player.data.playerClass == 193) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga");
	elseif(self.player.data.playerClass == 185) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga");
	elseif(self.player.data.playerClass == 162) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga");
	elseif(self.player.data.playerClass == 31) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga");
	elseif(self.player.data.playerClass == 24) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga");
	else
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	end
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	local iconeTop = 7;
	self.prof1Label = Turbine.UI.Control();
	self.prof1Label:SetParent( self );
	self.prof1Label:SetSize( 26, 24 );
	self.prof1Label:SetPosition( 200, iconeTop );
	self.prof1Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof1Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[1].name) );
	self.prof2Label = Turbine.UI.Control();
	self.prof2Label:SetParent( self );
	self.prof2Label:SetSize( 26, 24 );
	self.prof2Label:SetPosition( 240, iconeTop );
	self.prof2Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof2Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[2].name) );
	self.prof3Label = Turbine.UI.Control();
	self.prof3Label:SetParent( self );
	self.prof3Label:SetSize( 26, 24 );
	self.prof3Label:SetPosition( 280, iconeTop );
	self.prof3Label:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.prof3Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[3].name) );
	  
	self:UpdateNodeData(self.player);		
end

function CraftNode:GetPlayer()
	return self.player;
end

function CraftNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		self.player = p;
		local maxlvl = 13;
		self.prof1Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[1].name, self.player.data.profession[1].level==maxlvl) );
		local prof1labelTooltip = "Niveau d'aptitude : "..self:GetCraftLevelById(self.player.data.profession[1].level).."\n";
		if(self.player.data.profession[1].levelXP ~= "0/0") then prof1labelTooltip = prof1labelTooltip.."Expérience restante : "..self.player.data.profession[1].levelXP; end
		prof1labelTooltip = prof1labelTooltip.."\n\nNiveau de Maitrise : "..self:GetCraftLevelById(self.player.data.profession[1].mastery).."\n";
		if(self.player.data.profession[1].masteryXP ~= "0/0") then prof1labelTooltip = prof1labelTooltip.."Expérience restante : "..self.player.data.profession[1].masteryXP; end
		self.prof1Label.tooltip = ToolTip(self.prof1Label, self.player.data.profession[1].name, prof1labelTooltip, ToolTipLayout.MEDIUM);
		if(self.player.data.profession[1].level<2) then self.prof1Label:SetBlendMode( 1 ); end
		
		self.prof2Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[2].name, self.player.data.profession[2].level==maxlvl));
		local prof2labelTooltip = "Niveau d'aptitude : "..self:GetCraftLevelById(self.player.data.profession[2].level).."\n";
		if(self.player.data.profession[2].levelXP ~= "0/0") then prof2labelTooltip = prof2labelTooltip.."Expérience restante : "..self.player.data.profession[2].levelXP; end
		prof2labelTooltip = prof2labelTooltip.."\n\nNiveau de Maitrise : "..self:GetCraftLevelById(self.player.data.profession[2].mastery).."\n";
		if(self.player.data.profession[2].masteryXP ~= "0/0") then prof2labelTooltip = prof2labelTooltip.."Expérience restante : "..self.player.data.profession[2].masteryXP; end
		self.prof1Label.tooltip = ToolTip(self.prof2Label, self.player.data.profession[2].name, prof2labelTooltip, ToolTipLayout.MEDIUM);
		if(self.player.data.profession[2].level<2) then self.prof2Label:SetBlendMode( 1 ); end
		
		self.prof3Label:SetBackground( "WalmPlugins/BandOfFarmers/pictures/"..self:GetIconeByCraftName(self.player.data.profession[3].name, self.player.data.profession[3].level==maxlvl));
		local prof3labelTooltip = "Niveau d'aptitude : "..self:GetCraftLevelById(self.player.data.profession[3].level).."\n";
		if(self.player.data.profession[3].levelXP ~= "0/0") then prof3labelTooltip = prof3labelTooltip.."Expérience restante : "..self.player.data.profession[3].levelXP; end
		prof3labelTooltip = prof3labelTooltip.."\n\nNiveau de Maitrise : "..self:GetCraftLevelById(self.player.data.profession[3].mastery).."\n";
		if(self.player.data.profession[3].masteryXP ~= "0/0") then prof3labelTooltip = prof3labelTooltip.."Expérience restante : "..self.player.data.profession[3].masteryXP; end
		self.prof1Label.tooltip = ToolTip(self.prof3Label, self.player.data.profession[3].name, prof3labelTooltip, ToolTipLayout.MEDIUM);
		if(self.player.data.profession[3].level<2) then self.prof3Label:SetBlendMode( 1 ); end
	end
end

function CraftNode:GetCraftLevelById(level)
	if(level==1) then	return "Apprenti";
	elseif (level==2) then return "Compagnon";
	elseif (level==3) then return "Expert";
	elseif (level==4) then return "Artisan";
	elseif (level==5) then return "Maitre";
	elseif (level==6) then return "Supreme";
	elseif (level==7) then return "Ouestfolde";
	elseif (level==8) then return "Estemnet";
	elseif (level==9) then return "Ouestemnet";
	elseif (level==10) then return "Anorien";
	elseif (level==11) then return "Folde du Destin";
	elseif (level==12) then return "Crevasse de Fer";
	elseif (level==13) then return "Minas Ithil";
	elseif (level==0) then return "Débutant";
	else return "Niveau "..level;
	end
end

function CraftNode:GetIconeByCraftName(craft, gold)
	if(craft == "Tailleur") then
		if(gold==true) then return "actionPicker_icon_craft_tailor_gold.tga"; end
		return "actionPicker_icon_craft_tailor.tga";
	elseif(craft=="Cuisinier") then
		if(gold==true) then return "actionPicker_icon_cook_gold.tga"; end
		return "actionPicker_icon_cook.tga";
	elseif(craft=="Fermier") then
		if(gold==true) then return "actionPicker_icon_craft_farmer_gold.tga"; end
		return "actionPicker_icon_craft_farmer.tga";
	elseif(craft=="Forestier") then
		if(gold==true) then return "actionPicker_icon_craft_forester_gold.tga"; end
		return "actionPicker_icon_craft_forester.tga";
	elseif(craft=="Prospecteur") then
		if(gold==true) then return "actionPicker_icon_craft_prospector_gold.tga"; end
		return "actionPicker_icon_craft_prospector.tga";
	elseif(craft=="Ferronnier") then
		if(gold==true) then return "actionPicker_icon_craft_metalsmith_gold.tga"; end
		return "actionPicker_icon_craft_metalsmith.tga";
	elseif(craft=="Erudit") then
		if(gold==true) then return "actionPicker_icon_craft_scholar_gold.tga"; end
		return "actionPicker_icon_craft_scholar.tga";
	elseif(craft=="Fabricant d'armes") then
		if(gold==true) then return "actionPicker_icon_craft_weaponsmith_gold.tga"; end
		return "actionPicker_icon_craft_weaponsmith.tga";
	elseif(craft=="Menuisier") then
		if(gold==true) then return "actionPicker_icon_craft_woodworker_gold.tga"; end
		return "actionPicker_icon_craft_woodworker.tga";
	else
		if(gold==true) then return "actionPicker_icon_craft_jeweller_gold.tga"; end
		return "actionPicker_icon_craft_jeweller.tga";
	end
end