-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

import "WalmPlugins.BandOfFarmers.BandOfFarmers";
import "WalmPlugins.BandOfFarmers.QuickLauncher";
import "WalmPlugins.BandOfFarmers.Saving";
import "WalmPlugins.BandOfFarmers.ConfigDialog";

RtmCommand = Turbine.ShellCommand();

function RtmCommand:Execute( command, arguments )
	if ( arguments == "?" or arguments == "help" or arguments == "man") then
		Turbine.Shell.WriteLine(RtmCommand:GetHelp());
	elseif ( arguments == "show" ) then		
		OpenPane();	
	end
end

function RtmCommand:GetHelp()
	return "BandOfFarmers\nCe plugin permet de centraliser les infos de tous ses personages différents : or, craft et mémo."..
			"Commandes:\n/bof show => Affiche la fen&#234;tre listant les troupes.\n/bof options => Ouvre la fen&#234;tre de configuration.\n";
end

function RtmCommand:GetShortHelp()
	return "TODO.";
end

function OpenPane()
	if(bofDlg ~= nil) then
		bofDlg:SetVisible(true);
	end
end

function Savesettings()
	function SavesettingsConfirmation(sender, args)
		Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BandOfFarmers: settings sauvegardés</rgb>"));
	end
	DataSave(Turbine.DataScope.Account, "BandOfFarmers_preferences", settings);
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end

function Loadsettings()	
	local tmpsettings = DataLoad(Turbine.DataScope.Account, "BandOfFarmers_preferences");
	if(tmpsettings ~= nil) then
		settings = tmpsettings;		
	else
		Reinitsettings();
	end
end

function Reinitsettings()
	settings = {};
	local width, height = Turbine.UI.Display.GetSize();		
	local width2, height2;
	width2 = width/2 - 300/2;
	height2 = height/3 - 180/2;
	settings.main_x = width2;
	settings.main_y = height2;
	function ptr(sender, args)
		--
	end
	local tmpsettings = DataLoad(Turbine.DataScope.Account, "BandOfFarmers_preferences", ptr);
	if(tmpsettings ~= nil) then
		settings.quicklaunch_x = tmpsettings.quicklaunch_x-40;
		settings.quicklaunch_y = tmpsettings.quicklaunch_y;			
	else
		settings.quicklaunch_x = width-300;
		settings.quicklaunch_y = 20;	
	end
	settings.defaultOpacity = 60;
	settings.canMoveQuickLauncher = false;
	settings.useQuickLauncher = true;
	settings.autoShowOnLaunch = false;
	settings.animateQuickLauncher = true;
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end

Loadsettings();
-- 
plugin.GetOptionsPanel = function( self )
  	return BuildConfigDialog();
end
--

bofDlg = BandOfFarmers();
quickLauncher = QuickLauncher(bofDlg);
if(settings.useQuickLauncher) then
	quickLauncher:Start();
	quickLauncher:Applysettings();
end
if(settings.autoShowOnLaunch) then
	bofDlg:Start()
end

Turbine.Shell.AddCommand( "bof", RtmCommand );
Turbine.Shell.AddCommand( "BandOfFarmers", RtmCommand );

Turbine.Plugin.Unload = function ()
	if(settings.updateAtLaunchAndUnload) then
		bofDlg:UpdateLocalPlayerData();
	end
end
