
PlayerGoldNode = class( Turbine.UI.TreeNode );

function PlayerGoldNode:Constructor(p, hightlight)
	self.player = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 140, 28 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	if(self.player.data.level == nil) then
		self.playerNameLabel:SetText(self.player.name);
	else
		self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	end
	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end
	
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(self.player.data.playerClass == 172) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga");
	elseif(self.player.data.playerClass == 214) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga");
	elseif(self.player.data.playerClass == 40) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga");
	elseif(self.player.data.playerClass == 23) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga");
	elseif(self.player.data.playerClass == 194) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga");
	elseif(self.player.data.playerClass == 193) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga");
	elseif(self.player.data.playerClass == 185) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga");
	elseif(self.player.data.playerClass == 162) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga");
	elseif(self.player.data.playerClass == 31) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga");
	elseif(self.player.data.playerClass == 24) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga");
	else
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	end
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	local iconeTop = 9;
	local goldLabel = Turbine.UI.Control();
	goldLabel:SetParent( self );
	goldLabel:SetSize( 27, 21 );
	goldLabel:SetPosition( 203, iconeTop );
	goldLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	goldLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/inv_coin_gold.tga");
	local silverLabel = Turbine.UI.Control();
	silverLabel:SetParent( self );
	silverLabel:SetSize( 27, 21 );
	silverLabel:SetPosition( 245, iconeTop );
	silverLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	silverLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/inv_coin_silver.tga");
	local copperLabel = Turbine.UI.Control();
	copperLabel:SetParent( self );
	copperLabel:SetSize( 27, 21 );
	copperLabel:SetPosition( 285, iconeTop );
	copperLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	copperLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/inv_coin_copper.tga");

	self.goldValueLabel = Turbine.UI.Label();
	self.goldValueLabel:SetParent( self );
	self.goldValueLabel:SetSize( 40, 16 );
	self.goldValueLabel:SetPosition( 168, 11 );
	self.goldValueLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.goldValueLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	self.goldValueLabel:SetMouseVisible( false );
	self.goldValueLabel:SetText(math.floor(self.player.data.gold/100000));
	--self.goldValueLabel:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
	
	self.silverValueLabel = Turbine.UI.Label();
	self.silverValueLabel:SetParent( self );
	self.silverValueLabel:SetSize( 40, 16 );
	self.silverValueLabel:SetPosition( 210, 11 );
	self.silverValueLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.silverValueLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	self.silverValueLabel:SetMouseVisible( false );
	self.silverValueLabel:SetText(math.floor(self.player.data.gold/100%1000));	

	self.copperValueLabel = Turbine.UI.Label();
	self.copperValueLabel:SetParent( self );
	self.copperValueLabel:SetSize( 40, 16 );
	self.copperValueLabel:SetPosition( 250, 11 );
	self.copperValueLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.copperValueLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	self.copperValueLabel:SetMouseVisible( false );
	self.copperValueLabel:SetText(math.floor(self.player.data.gold%100));	

	self:UpdateNodeData();		
end

function PlayerGoldNode:GetPlayer()
	return self.player;
end

function PlayerGoldNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		self.player = p;
		self.goldValueLabel:SetText(math.floor(self.player.data.gold/100000));
		self.silverValueLabel:SetText(math.floor(self.player.data.gold/100%1000));	
		self.copperValueLabel:SetText(math.floor(self.player.data.gold%100));	
		self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	end
end
