import "WalmPlugins.BandOfFarmers.TextNode";
import "WalmPlugins.BandOfFarmers.PlayerTokenNode";


TokenSearchNode = class( Turbine.UI.TreeNode );


function TokenSearchNode:Constructor(playersData, parentTreeView)
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 70 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue_large.tga");
	self.searching = true;
	
	self.textLabel = Turbine.UI.Label();
	self.textLabel:SetParent( self );
	self.textLabel:SetSize( 140, 14 );
	self.textLabel:SetPosition( 40, 6 );
	self.textLabel:SetZOrder(100);
	self.textLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.textLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.textLabel:SetMouseVisible( false );
	self.textLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	self.textLabel:SetText("Chercher :");
	
	self.resultLabel = Turbine.UI.Label();
	self.resultLabel:SetParent( self );
	self.resultLabel:SetSize( 65, 20 );
	self.resultLabel:SetPosition( 245, 0 );
	self.resultLabel:SetZOrder(100);
	self.resultLabel:SetFont( Turbine.UI.Lotro.Font.Verdana10	 );	
	self.resultLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.resultLabel:SetMouseVisible( false );
	--self.resultLabel:SetBackColor(Turbine.UI.Color( 1, 1, 0.5 ));
	self.resultLabel:SetText("XXX résultats");	
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
	self.classLabel:SetPosition( 6, 5 );
	self.classLabel:SetSize( 26, 24 );
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	self.textArea = Turbine.UI.Lotro.TextBox();
	self.textArea:SetParent( self );
	self.textArea:SetPosition( 110, self.textLabel:GetTop()-3 );
	self.textArea:SetSize( 130 , 20 );
	self.textArea:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.textArea:SetMultiline(false);
	self.textArea.TextChanged = function ()
		self:BuildTokensList(playersData, string.lower(self.textArea:GetText()));	
	end

	local topTreeView = 24;
	self.treeView = Turbine.UI.TreeView();
    self.treeView:SetParent( self );
    self.treeView:SetPosition( 42, topTreeView );
    self.treeView:SetSize( self:GetWidth()-60, 40 );
    self.treeView:SetIndentationWidth( 15 );
	local sortMethod = function (node1, node2)
		if node1== nil or node2==nil then
			return true;
		end
		if (node1:GetText() > node2:GetText()) then
			return true
		end
	end
    self.treeView:SetSortMethod( sortMethod );
	--self.treeView:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	local treeViewScrollBar = Turbine.UI.Lotro.ScrollBar();
    treeViewScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    treeViewScrollBar:SetParent( self );
    treeViewScrollBar:SetPosition(self:GetWidth()-15, topTreeView );
    treeViewScrollBar:SetSize( 10, self.treeView:GetHeight() );
	self.treeView:SetVerticalScrollBar( treeViewScrollBar );



	self:BuildTokensList(playersData, "");
	
	self.treeView.SelectedNodeChanged = function()
		local node = self.treeView:GetSelectedNode();
		if(node.item == nil) then return; end;
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>BandOfFarmers: Node séléctionné : ".. node:GetText() .."</rgb>");
		-- for i=1 , parentTreeView:GetNodes():GetCount() , 1 do
			-- if(parentTreeView:GetNodes():Get(i).searching ~= true) then 
				-- parentTreeView:GetNodes():RemoveAt(i); 
				-- i = i-1; 
			-- end
		-- end
		local pnode = parentTreeView:GetNodes():Get(1);
		parentTreeView:GetNodes():Clear();
		parentTreeView:GetNodes():Add(pnode);
		if(node.itemValues ~= nil) then
			for i=1 , table.getn(node.itemValues) , 1 do
				local node = PlayerTokenNode(node.itemValues[i], node.item);
				parentTreeView:GetNodes():Add(node);
			end
		end
	end
	
end

function TokenSearchNode:BuildTokensList(playersData, search)
	self.treeView:GetNodes():Clear();
	
	-- local parentNode = TextNode("Je suis le parent");
	-- self.treeView:GetNodes():Add(parentNode);
	
	for i=1 , table.getn(playersData), 1 do
		local player = playersData[i];
		if player.data.wallet ~= nil then
			for k=1 , table.getn(player.data.wallet) , 1 do
				if string.match(string.lower(player.data.wallet[k].name), search) then
					local found = false;				
					for j=1 , self.treeView:GetNodes():GetCount(), 1 do
						local node = self.treeView:GetNodes():Get(j);
						if(node.item ~= nil and node.item.name == player.data.wallet[k].name) then
							local value = {};
							value.playerName = player.name;
							value.playerLevel = player.data.level;
							value.playerClass = player.data.playerClass;
							value.playerQuantity = player.data.wallet[k].quantity;
							node:SetValue(value.playerQuantity + node:GetValue());
							table.insert(node.itemValues, value);
							found = true;
						end
					end
					if (found == false) then
						local node = TextNode(player.data.wallet[k].name, player.data.wallet[k].quantity, 250, 12);
						node.item = player.data.wallet[k];
						node.itemValues = {};
						local value = {};
						value.playerName = player.name;
						value.playerLevel = player.data.level;
						value.playerClass = player.data.playerClass;
						value.playerQuantity = player.data.wallet[k].quantity;
						table.insert(node.itemValues, value);
						self.treeView:GetNodes():Add(node);
					end
				end
			end
		end
	
	end
	-- parentNode:SetText("Nombre de résultats: "..parentNode:GetChildNodes():GetCount());
	-- self.treeView:ExpandAll();
	self.resultLabel:SetText(""..self.treeView:GetNodes():GetCount().. " résultats");	
end

