import "WalmPlugins.BandOfFarmers.DropDown";

WalletsNode = class( Turbine.UI.TreeNode );

function WalletsNode:Constructor(p)
	self.players = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	
	local playerNameLabel = Turbine.UI.Label();
	playerNameLabel:SetParent( self );
	playerNameLabel:SetSize( 140, 28 );
	playerNameLabel:SetPosition( 42, 3 );
	playerNameLabel:SetZOrder(100);
	playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	playerNameLabel:SetMouseVisible( false );
	playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));

	
	classLabel = Turbine.UI.Control();
	classLabel:SetParent( self );
	classLabel:SetSize( 20, 20 );
	classLabel:SetPosition( 9, 7 );
	classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
	classLabel:SetPosition( 6, 5 );
	classLabel:SetSize( 26, 24 );
	classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	classLabel:SetMouseVisible( false );

	local itemsList = self:BuildWalletItemsList(self.players);
	--table.sort(itemsList, sortWalletItemsByName);
	self.itemsDropDown = DropDown.Create(itemsList, nil); -- table that contains the list, default selected value for the list
	self.itemsDropDown:SetParent(self);
	self.itemsDropDown:SetPosition(100, 8);
	self.itemsDropDown.myElementList = elementList;
	self.itemsDropDown:ApplyWidth(200);
	self.itemsDropDown:SetMaxItems(table.getn(itemsList));
	self.itemsDropDown:SetVisible(true);
	self.itemsDropDown.ItemChanged = function ()
		-- TODO
	end

	self:UpdateNodeData(self.players);		
end

function WalletsNode:BuildWalletItemsList(players)
	local list = {};
	for i=1 , table.getn(players) , 1 do
		local player = players[i];
		if(player.data~=nil and player.data.wallet~= nil) then
			for j=1 , table.getn(player.data.wallet) , 1 do
				if(self:IndexOf(list, player.data.wallet[j]) == nil) then
					table.insert(list, player.data.wallet[j]);
				end
			end
		end
	end
	return list;
end

function WalletsNode:IndexOf(t, element)
	if(t==nil) then	
		return nil;
	end
	for i=1 , table.getn(t) , 1 do
		local e = t[i];
		if(e.name == element.name) then
			return e;
		end
	end
	return nil;
end

function WalletsNode:GetPlayer()
	return self.player;
end

function WalletsNode:UpdateNodeData(p)
	-- if p~= nil and p.name == self.player.name  then

	-- end
end

function sortWalletItemsByName(wItem1,wItem2)
	return wItem1 < wItem2;
end